// CleanUpHTML.cpp : Defines the class behaviors for the application.
//
#include "stdafx.h"
#include "MyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const char * const mruCount = _T("mruCount");
/////////////////////////////////////////////////////////////////////////////
// CCleanUpHTMLApp

BEGIN_MESSAGE_MAP(CCleanUpHTMLApp, CWinApp)
	//{{AFX_MSG_MAP(CCleanUpHTMLApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_PRINT_SETUP, OnFilePrintSetup)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCleanUpHTMLApp construction

CCleanUpHTMLApp::CCleanUpHTMLApp()
{
	m_mruCount = _AFX_MRU_COUNT;
	m_initSelStart = 0;
	m_initSelAfter = 0;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CCleanUpHTMLApp object

CCleanUpHTMLApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CCleanUpHTMLApp initialization

BOOL CCleanUpHTMLApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(OSB);

	m_mruCount = GetProfileInt(settings, mruCount, _AFX_MRU_COUNT);
	// Load standard INI file options (including MRU)
	LoadStdProfileSettings(m_mruCount);

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CCleanUpHTMLDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CCleanUpHTMLView));
	AddDocTemplate(pDocTemplate);

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

// replace normal shell open since it wont handle path names with spaces in it

   if(m_lpCmdLine[0] == _T('\0'))
   {
      // Create a new (empty) document.
      OnFileNew();
   }
   else // open a command line document and possibly go to and hilight a selection
   {
 		// app /iss number/isa number
		// switches for m_initSelStart and m_initSelAfter variables, app is the file to open

	    char *p = ::strstr(m_lpCmdLine, _T("/iss"));
	    char *q = ::strstr(m_lpCmdLine, _T("/isa"));
	   
		if(!p || !q || 
		   1 != ::sscanf(p, _T("/iss%d"), &m_initSelStart) || 
		   1 != ::sscanf(q, _T("/isa%d"), &m_initSelAfter) ||
		   m_initSelStart > m_initSelAfter)
		{
			m_initSelStart = m_initSelAfter = 0;
		}

	   	// Open a file passed as the first command line parameter.
		OpenDocumentFile(m_lpCmdLine);
		// reset initial hilghting to none
		m_initSelStart = m_initSelAfter = 0;
   }
  
	// Parse command line for standard shell commands, DDE, file open
//	CCommandLineInfo cmdInfo;
//	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
//	if (!ProcessShellCommand(cmdInfo))
//		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CBitmapButton	m_emailButton;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnEmail();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_EMAIL_BTN, m_emailButton);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_EMAIL_BTN, OnEmail)
	ON_WM_SETCURSOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CCleanUpHTMLApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CCleanUpHTMLApp message handlers

void CAboutDlg::OnEmail() 
{
	CString url(MAIL2);
	url += MY_EMAIL_URL;
	url += SUBJECT;
	
	if((UINT)ShellExecute(NULL, _T("open"), url, NULL, NULL, SW_NORMAL) <= HINSTANCE_ERROR)
	{
		MessageBox("Problem sending mail.", "Send Dick Mail", MB_ICONERROR);
	}
	
	return;
}

BOOL CAboutDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// show hand cursor if over the email bitmap button
	if(pWnd == (CWnd *)GetDlgItem(IDC_EMAIL_BTN))
	{
		::SetCursor(AfxGetApp()->LoadCursor(IDC_CURSOR_HAND));
   		return TRUE;
	}
	
	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

BOOL CAboutDlg::OnInitDialog() 
{

	m_emailButton.AutoLoad(IDC_EMAIL_BTN, this);
	
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCleanUpHTMLApp::OnFilePrintSetup() 
{
	CPrintDialog aDlg(TRUE);

	aDlg.m_pd.Flags |= PD_RETURNDEFAULT;	// silent running to fill out devmode structure
	aDlg.DoModal();
	aDlg.m_pd.Flags &= ~PD_RETURNDEFAULT;

	LPDEVMODE pDevMode = aDlg.GetDevMode();

	if(pDevMode)
	{
		pDevMode->dmOrientation = ((CMainFrame *)AfxGetMainWnd())->m_printOrientation;
		pDevMode->dmPaperSize   = ((CMainFrame *)AfxGetMainWnd())->m_printPaperSize;
		
		::GlobalUnlock(aDlg.m_pd.hDevMode);

		if(IDOK == aDlg.DoModal())
		{
			pDevMode = aDlg.GetDevMode();
			((CMainFrame *)AfxGetMainWnd())->m_printOrientation = pDevMode->dmOrientation;
			::GlobalUnlock(aDlg.m_pd.hDevMode);
		}
	}
}

int CCleanUpHTMLApp::ExitInstance() 
{
	WriteProfileInt(settings, mruCount, m_mruCount);
	
	return CWinApp::ExitInstance();
}
