// CleanUpHTMLView.h : interface of the CCleanUpHTMLView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CLEANUPHTMLVIEW_H__3928F3E7_2BD2_4F88_ACF3_C7F650EA10C1__INCLUDED_)
#define AFX_CLEANUPHTMLVIEW_H__3928F3E7_2BD2_4F88_ACF3_C7F650EA10C1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CCleanUpHTMLView : public CEditView
{
protected: // create from serialization only
	CCleanUpHTMLView();
	DECLARE_DYNCREATE(CCleanUpHTMLView)

// Attributes
public:
	CCleanUpHTMLDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCleanUpHTMLView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	CString	m_strPathIExplorer;
	void UpdateFileStatus(BOOL bSaveAndRetrieve); // save == FALSE, retrieve == TRUE
	BOOL m_bIsUnix;
	void MySerializeRaw(CArchive & ar);
	BOOL m_bNextFound;
	CPoint m_posFindMarkDlg;
	CPoint m_posSettingsDlg;
	CDialog * m_pFindMarkReplaceDlg;
	int m_charHeight;
	int m_charWidth;
	void ForceCRLFonLoad();
	BOOL m_bConfirm;
	BOOL bIsHTML();
	BOOL GetReadOnly();
	void SetReadOnly(BOOL bReadOnly);
	virtual ~CCleanUpHTMLView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	ULONG m_tick;
	void TabOverLines();
	CURL url;
	int m_horizGuideTop;
	int m_horizGuideBottom;
	int m_horizGuideFirstLine;
	void SetBookmark(int line);
	void GetAllSelectedText(CString & strResult);
	int m_nExtraCR;
	UINT m_subfolderDepth;
	BOOL m_bFindInFilesMatchCase;
	BOOL m_bFindInFilesMatchWhole;
	CString m_findInFilesFileTypeStr;
	CString m_findInFilesFindWhatStr;
	CString m_findInFilesFolderStr;
	BOOL m_bDelTempAsap;
	void OnRemoveWhitespace(BOOL bRemoveLF);
	int m_columnMarkOffset;
	UINT m_statusBarFlashCount;
	COLORREF m_statusBarBkColor;
	BOOL m_bGettingColor;
	CStringArray m_ringClipBdArray;
	UINT m_offsetOpenHtmlTag;
	UINT m_offsetCloseHtmlTag;	
	CString	m_strPathWinDiff;
	CString	m_strUrlHtmlHelp;
	CString	m_strUrlCssHelp;
	CString	m_strUrlPhpHelp;
	CString	m_strPathGraphics;
	void ResetUndo();
	BOOL m_bInhibitUndoOnChange;
	CString m_strShadow;
	UINT m_lenEditBuffer;
	CArray<int, int> m_posUndo;
	CArray<BOOL, BOOL> m_bReplace;
	CStringArray m_strChangeUndo;
	UINT m_undoLevel;

	UINT m_numMarginWidth;
	UINT m_nLinesPerPrinterPage;
	BOOL m_bPrinterLineNum;
	CArray <UINT, UINT> m_startOfPrintLine;
	BOOL m_bPrintHeader;
	BOOL m_bPrintFooter;
	CSize m_pageSize;
	CRect m_marginRect;
	int m_footerHeight;
	int m_headerHeight;
	int m_printerLineHeight;
	int m_goToLineNum;
	int m_lineCnt;
	void SetAllAttributes();
	UINT m_nBookMarks;
	int m_charSet;
	int m_pitchStyle;
	void OnChangeFont();
	CString m_fontFaceName;
	int m_printerPtSize;
	int m_fontPtSize;
	BOOL m_bWholeWord;
	BOOL m_bMatchCase;
	BOOL m_bFindDirection;
	int m_firstChar;
	void OnMyMarkAll();
	BOOL m_bWasTabRemovalError;
	UINT m_tabChars;
	CStringArray m_findStrArray;
	CStringArray m_replaceStrArray;
	void ForceSelIntoView();
	BOOL m_bSilent;
	int m_marginCharWidth;
	int m_horzScrollPos;
	int m_vertScrollPos;
	BOOL m_bMarkStrings;
	BOOL m_bScrollCenter;
	void ScrollToScrnCntr();
	CStringArray m_tempFileStrArray;
	int m_nTempFileNumber;
	BOOL m_bReadOnly;
	BOOL m_bLineGuide;
	DWORD GetLineAndColumn();
	CString m_positionStr;
	CFont * m_pFont;
	CFont * m_pPrinterFont;
	CString m_findStr;
	CString m_markStr;
	CString m_lastFindStr;
	BOOL m_bWrap;
	BOOL m_bRestoreState;
	BOOL m_bShowLineNum;
	int m_fontIndex;
	CEdit & m_editCtrl;
	//{{AFX_MSG(CCleanUpHTMLView)
	afx_msg void OnReadOnly();
	afx_msg void OnUpdateReadOnly(CCmdUI* pCmdUI);
	afx_msg void OnShowLineNumbers();
	afx_msg void OnUpdateShowLineNumbers(CCmdUI* pCmdUI);
	afx_msg void OnGetSelHex();
	afx_msg void OnInsertHex();
	afx_msg void OnUpdateInsertHex(CCmdUI* pCmdUI);
	afx_msg void OnWordWrap();
	afx_msg void OnUpdateWordWrap(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditFind(CCmdUI* pCmdUI);
	afx_msg void OnSelBetweenTags();
	afx_msg void OnUpdateParse(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGetSelHex(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrintPreview(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnOpenInBrowser();
	afx_msg void OnUpdateOpenInBrowser(CCmdUI* pCmdUI);
	afx_msg void OnHtmlFormat();
	afx_msg void OnUpdateHtmlFormat(CCmdUI* pCmdUI);
	afx_msg void OnFileDelete();
	afx_msg void OnUpdateFileDelete(CCmdUI* pCmdUI);
	afx_msg void OnFileReopen();
	afx_msg void OnUpdateFileReopen(CCmdUI* pCmdUI);
	afx_msg void OnFindNextTag();
	afx_msg void OnUpdateFindNextTag(CCmdUI* pCmdUI);
	afx_msg void OnFindPreviousTag();
	afx_msg void OnUpdateFindPreviousTag(CCmdUI* pCmdUI);
	afx_msg void OnFindNextUntagged();
	afx_msg void OnUpdateFindNextUntaged(CCmdUI* pCmdUI);
	afx_msg void OnFindPreviousUntagged();
	afx_msg void OnUpdateFindPreviousUntagged(CCmdUI* pCmdUI);
	afx_msg void OnGoToLine();
	afx_msg void OnUpdateGoToLine(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnVscroll();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnChange();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnEscape();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnHscroll();
	afx_msg void OnSelAll();
	afx_msg void OnSettings();
	afx_msg void OnHilight();
	afx_msg void OnUpdateHilight(CCmdUI* pCmdUI);
	afx_msg void OnCheckFont();
	afx_msg void OnBmClear();
	afx_msg void OnBmNext();
	afx_msg void OnBmPrevious();
	afx_msg void OnUpdateBm(CCmdUI* pCmdUI);
	afx_msg void OnBmToggle();
	afx_msg void OnScrollToCursor();
	afx_msg void OnTableTrace();
	afx_msg void OnUpperCase();
	afx_msg void OnUpdateUpperCase(CCmdUI* pCmdUI);
	afx_msg void OnLowerCase();
	afx_msg void OnUpdateLowerCase(CCmdUI* pCmdUI);
	afx_msg void OnReverseCase();
	afx_msg void OnUpdateReverseCase(CCmdUI* pCmdUI);
	afx_msg void OnEditDelete();
	afx_msg void OnUpdateEditDelete(CCmdUI* pCmdUI);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnUpdateEditCut(CCmdUI* pCmdUI);
	afx_msg void OnUpdate();
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnEditRedo();
	afx_msg void OnUpdateEditRedo(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnEditPaste();
	afx_msg void OnWindiff();
	afx_msg void OnUpdateWindiff(CCmdUI* pCmdUI);
	afx_msg void OnGoToChar();
	afx_msg void OnUpdateGoToChar(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSelAll(CCmdUI* pCmdUI);
	afx_msg void OnDeleteTempFiles();
	afx_msg void OnUpdateDeleteTempFiles(CCmdUI* pCmdUI);
	afx_msg void OnInsertTag();
	afx_msg void OnEditCopy();
	afx_msg void OnEditCut();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnEditPasteLIFO();
	afx_msg void OnUpdateEditPasteLIFO(CCmdUI* pCmdUI);
	afx_msg void OnViewGetColor();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnFileOpenGrphics();
	afx_msg void OnUpdateFileOpenGrphics(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnViewColMark();
	afx_msg void OnUpdateViewColMark(CCmdUI* pCmdUI);
	afx_msg void OnViewShowColor();
	afx_msg void OnUpdateViewShowColor(CCmdUI* pCmdUI);
	afx_msg void OnCharCodes();
	afx_msg void OnEditLoremIpsum();
	afx_msg void OnFormatCss();
	afx_msg void OnUpdateFormatCss(CCmdUI* pCmdUI);
	afx_msg void OnCssRemoveWhitespace();
	afx_msg void OnUpdateCssRemoveWhitespace(CCmdUI* pCmdUI);
	afx_msg void OnHtmRemoveWhitespace();
	afx_msg void OnUpdateHtmRemoveWhitespace(CCmdUI* pCmdUI);
	afx_msg void OnCssWebReference();
	afx_msg void OnHtmlWebReference();
	afx_msg void OnEditAsciiChars();
	afx_msg void OnFindInFiles();
	afx_msg void IsAscii();
	afx_msg void OnUpdateIsAscii(CCmdUI* pCmdUI);
	afx_msg void OnInsertScript();
	afx_msg void OnInsertStyle();
	afx_msg void OnDestroy();
	afx_msg void OnViewLineGuide();
	afx_msg void OnUpdateViewLineGuide(CCmdUI* pCmdUI);
	afx_msg void OnViewIncreaseFont();
	afx_msg void OnViewDecreaseFont();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnUpdateCharCodes(CCmdUI* pCmdUI);
	afx_msg void OnCssBasic();
	afx_msg void OnHelpDoc();
	afx_msg void OnPhpWebReference();
	afx_msg void OnInsertHtmlComment();
	afx_msg void OnInsertPhpCodeBlock();
	afx_msg void OnInsertPhpEchoBlock();
	afx_msg void OnCountMarked();
	afx_msg void OnUpdateCountMarked(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg void OnUpdateIndicator(CCmdUI* pCmdUI); 
	afx_msg void OnUpdateFileSize(CCmdUI* pCmdUI); 
	afx_msg void UpdateLineNumbers(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg void OpenMsg(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg void MarkAllLikeText(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg void OnUpdateLineCnt(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBMCnt(CCmdUI* pCmdUI);
	afx_msg void OnUpdateIsUnix(CCmdUI* pCmdUI);
	afx_msg void FindMarkReturn(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg void OnMyFindNext(WPARAM wParam = 0, LPARAM lParam = 0);
	afx_msg void OnFindMark(UINT nID);
	afx_msg void OnUpdateFindMark(CCmdUI* pCmdUI);
	afx_msg void OnInsertXHTML(UINT nID);
	afx_msg void OnUpdateInsertXHTML(CCmdUI* pCmdUI);
 	afx_msg void OnHtmlCodes(UINT nID);
 	afx_msg void OnUpdateHtmlCodes(CCmdUI* pCmdUI);

	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in CleanUpHTMLView.cpp
inline CCleanUpHTMLDoc* CCleanUpHTMLView::GetDocument()
   { return (CCleanUpHTMLDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLEANUPHTMLVIEW_H__3928F3E7_2BD2_4F88_ACF3_C7F650EA10C1__INCLUDED_)
