// FindMarkDlg.cpp : implementation file
//
#include "stdafx.h"
#include "MyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFindMarkDlg dialog


CFindMarkDlg::CFindMarkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFindMarkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFindMarkDlg)
	m_bMatchCase = FALSE;
	m_bMatchWhole = FALSE;
	m_findDirection = -1;
	m_bScrollCenter = FALSE;
	//}}AFX_DATA_INIT
	m_pFindStrArray = NULL;
	m_bFindReplace = TRUE; // TRUE == FIND MARK, FALSE = REPLACE
}


void CFindMarkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindMarkDlg)
	DDX_Control(pDX, IDC_COMBO_REPLACE, m_comboReplace);
	DDX_Control(pDX, IDC_COMBO_FIND, m_comboFind);
	DDX_Check(pDX, IDC_CHECK_MATCH_CASE, m_bMatchCase);
	DDX_Check(pDX, IDC_CHECK_MATCH_WHOLE, m_bMatchWhole);
	DDX_Radio(pDX, IDC_DIRECTION_UP, m_findDirection);
	DDX_Check(pDX, IDC_SCROLL_TO_CENTER, m_bScrollCenter);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFindMarkDlg, CDialog)
	//{{AFX_MSG_MAP(CFindMarkDlg)
	ON_BN_CLICKED(IDC_BUTTON_MARK_ALL, OnButtonMarkAll)
	ON_BN_CLICKED(IDC_BUTTON_FIND_NEXT, OnButtonFindNext)
	ON_BN_CLICKED(IDC_BUTTON_DEL_FIND_STRS, OnButtonDelFindStrs)
	ON_WM_CLOSE()
	ON_BN_CLICKED(ID_MY_CANCEL, OnMyCancel)
	ON_BN_CLICKED(IDC_BUTTON_DEL_REPLACE_STR, OnButtonDelReplaceStr)
	ON_BN_CLICKED(IDC_BUTTON_REPLACE, OnButtonReplace)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindMarkDlg message handlers

// useed for both REPLACE ALL and MARK ALL for m_bFindReplace FALSE = REPLACE, TRUE = FIND MARK 
void CFindMarkDlg::OnButtonMarkAll() 
{
	ReturnData(IDC_BUTTON_MARK_ALL);
}

void CFindMarkDlg::OnButtonFindNext() 
{
	ReturnData(IDC_BUTTON_FIND_NEXT);
}

void CFindMarkDlg::OnButtonReplace() 
{
	ReturnData(IDC_BUTTON_REPLACE);	
}

void CFindMarkDlg::ReturnData(UINT retVal)
{
	UpdateData(TRUE);

	_FIND_MARK_STRUCT_ fm;

	m_comboFind.GetWindowText(m_findStr);
	m_comboReplace.GetWindowText(m_replaceStr);

	if(!m_findStr.IsEmpty()) // both FIND MARK and REPLACE must have a find string
	{
		if(retVal != 0)
		{
			fm.findStr = m_findStr.GetBuffer(m_findStr.GetLength() + 1);
			fm.replaceStr = m_replaceStr.GetBuffer(m_replaceStr.GetLength() + 1);
			fm.bMatchCase = m_bMatchCase;
			fm.bMatchWhole = m_bMatchWhole;
			fm.bScrollCenter = m_bScrollCenter;
			fm.findDirection = m_findDirection;
			fm.retVal = retVal;
			fm.bFindReplace = m_bFindReplace;

			m_pEditView->SendMessage(WM_FIND_MARK_RETURN, 0, (LPARAM)&fm);

			AddComboBoxStr();

			CButton * pButton = (CButton *)GetDlgItem(IDC_BUTTON_DEL_FIND_STRS);
			pButton->EnableWindow(TRUE);
		}
	}
	else
	{
		MessageBeep(0xFFFFFFFF);
	}
}

void CFindMarkDlg::AddComboBoxStr()
{
	CString aStr;
	m_comboFind.GetWindowText(aStr);
	int nStr = m_pFindStrArray->GetSize();
	if(!aStr.IsEmpty() && (!nStr || aStr != m_pFindStrArray->GetAt(0)))
	{
		m_pFindStrArray->InsertAt(0, aStr);
		m_comboFind.InsertString(0, aStr);

		if(m_pFindStrArray->GetSize() > MAX_NUM_COMBO_BOX_FIND_STR)
		{
			m_pFindStrArray->RemoveAt(m_pFindStrArray->GetSize() - 1);
		}
	}

	if(m_bFindReplace == FALSE) // REPLACE DIALOG
	{
		m_comboReplace.GetWindowText(aStr);
		int nStr = m_pReplaceStrArray->GetSize();
		if(!aStr.IsEmpty() && (!nStr || aStr != m_pReplaceStrArray->GetAt(0)))
		{
			m_pReplaceStrArray->InsertAt(0, aStr);
			m_comboReplace.InsertString(0, aStr);

			if(m_pReplaceStrArray->GetSize() > MAX_NUM_COMBO_BOX_FIND_STR)
			{
				m_pReplaceStrArray->RemoveAt(m_pReplaceStrArray->GetSize() - 1);
			}
		}
	}
}

BOOL CFindMarkDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// load find strings into combo box
	int nStr = m_pFindStrArray->GetSize();

	for(int i = 0; i < nStr; i++)
	{
		m_comboFind.AddString(m_pFindStrArray->GetAt(i));	
	}

	if(!nStr)
	{
		CButton * pButton = (CButton *)GetDlgItem(IDC_BUTTON_DEL_FIND_STRS);
		pButton->EnableWindow(FALSE);
	}

	m_comboFind.SetWindowText(m_findStr);

	// load replace strings into combo box
	nStr = m_pReplaceStrArray->GetSize();

	for(i = 0; i < nStr; i++)
	{
		m_comboReplace.AddString(m_pReplaceStrArray->GetAt(i));	
	}

	if(!nStr)
	{
		CButton * pButton = (CButton *)GetDlgItem(IDC_BUTTON_DEL_REPLACE_STR);
		pButton->EnableWindow(FALSE);
	}

	m_comboReplace.SetWindowText(nStr ? m_pReplaceStrArray->GetAt(0) : "");

	// condigure for FIND or REPLACE dialog
	WINDOWPLACEMENT wp;
	// get amount to move up if necessary
	CWnd * pWnd1 = (CWnd *)GetDlgItem(IDC_BUTTON_MARK_ALL);
	pWnd1->GetWindowPlacement(&wp);
	int y1 = ((CRect)wp.rcNormalPosition).top;

	CWnd * pWnd2 = (CWnd *)GetDlgItem(ID_MY_CANCEL);
	pWnd2->GetWindowPlacement(&wp);
	int y2 = ((CRect)wp.rcNormalPosition).top;

	// m_bFindReplace FALSE = REPLACE, TRUE = FIND MARK 
	int delY = m_bFindReplace ? y2 - y1 : 0; // amount to close up FIND window

	// change text
	SetWindowText(m_bFindReplace ? "DicksEditor - Find and Mark" : "DicksEditor - Replace");
	pWnd1->SetWindowText(m_bFindReplace == FIND ? "Mark All" : "Replace All");

	// remove dialog controls if necessary
	static const UINT showHideIDs[] = {IDC_BUTTON_REPLACE, IDC_STATIC_REPLACE, IDC_COMBO_REPLACE, IDC_BUTTON_DEL_REPLACE_STR};
	
	for(i = 0; i < NUM_ELEMENTS(showHideIDs); i++)
	{
		pWnd1 = (CWnd *)GetDlgItem(showHideIDs[i]);
		pWnd1->ShowWindow(m_bFindReplace == FIND ? SW_HIDE : SW_SHOW);
	}

	pWnd1 = (CWnd *)GetDlgItem(IDC_STATIC_TEXT);
	pWnd1->ShowWindow(m_bFindReplace == FIND ? SW_SHOW : SW_HIDE );

	// move dialog controls up if necessary

	if(delY)
	{
		static const UINT moveIDs[] = {IDC_BUTTON_MARK_ALL, ID_MY_CANCEL, IDC_STATIC_TEXT, IDC_STATIC_DIRECTION, 
									   IDC_DIRECTION_UP, IDC_DIRECTION_DN, IDC_CHECK_MATCH_WHOLE, 
									   IDC_CHECK_MATCH_CASE, IDC_SCROLL_TO_CENTER};
		
		for(i = 0; i < NUM_ELEMENTS(moveIDs); i++)
		{
			pWnd1 = (CWnd *)GetDlgItem(moveIDs[i]);
			pWnd1->GetWindowPlacement(&wp);
			pWnd1->SetWindowPos(NULL, ((CRect)wp.rcNormalPosition).left, ((CRect)wp.rcNormalPosition).top - delY, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		}

	}
	// restore dialog to last used position or center if first time and
	// close up the dialog window if necessary
	GetWindowPlacement(&wp);
	SetWindowPos(NULL, m_posFindMarkDlg.x, m_posFindMarkDlg.y, 
					   ((CRect)wp.rcNormalPosition).Width(), ((CRect)wp.rcNormalPosition).Height() - delY, 
						SWP_NOZORDER);
	return TRUE;
 }

void CFindMarkDlg::OnButtonDelFindStrs() 
{
	if(m_comboFind.GetCount())
	{
		if(IDYES == MessageBox("Delete all previous Find strings ?", "Find and Mark", MB_ICONQUESTION | MB_YESNOCANCEL | MB_DEFBUTTON2))
		{
			CString aStr;
			m_comboFind.GetWindowText(aStr);
			m_comboFind.ResetContent();
			m_pFindStrArray->RemoveAll();
			m_comboFind.SetWindowText(aStr);
			CButton * pButton = (CButton *)GetDlgItem(IDC_BUTTON_DEL_FIND_STRS);
			pButton->EnableWindow(FALSE);
		}
	}
}

void CFindMarkDlg::OnButtonDelReplaceStr() 
{
	if(m_comboReplace.GetCount())
	{
		if(IDYES == MessageBox("Delete all previous Replace strings ?", "Find and Replace", MB_ICONQUESTION | MB_YESNOCANCEL | MB_DEFBUTTON2))
		{
			CString aStr;
			m_comboReplace.GetWindowText(aStr);
			m_comboReplace.ResetContent();
			m_pReplaceStrArray->RemoveAll();
			m_comboReplace.SetWindowText(aStr);
			CButton * pButton = (CButton *)GetDlgItem(IDC_BUTTON_DEL_REPLACE_STR);
			pButton->EnableWindow(FALSE);
		}
	}
}

void CFindMarkDlg::PostNcDestroy() 
{
	CDialog::PostNcDestroy();

	m_pEditView->m_pFindMarkReplaceDlg = NULL;
	delete this;
}

void CFindMarkDlg::OnCancel() 
{
// [esc] key press ignore
}

void CFindMarkDlg::OnOK() 
{
// return key press ignore
}

void CFindMarkDlg::OnClose() 
{
	WINDOWPLACEMENT wp;
	GetWindowPlacement(&wp);
	m_pEditView->m_posFindMarkDlg = ((CRect)wp.rcNormalPosition).TopLeft();

	DestroyWindow();
}

void CFindMarkDlg::OnMyCancel() 
{
	OnClose();
}



