// MainFrm.cpp : implementation of the CMainFrame class
//
#include "stdafx.h"
#include "MyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_GETMINMAXINFO()
	ON_COMMAND(ID_NEW_APP, OnNewEditor)
	ON_COMMAND(ID_FILE_PAGE_SETUP, OnFilePageSetup)
	ON_COMMAND(ID_TOGGLE_HTML_TOOLBAR, OnToggleHtmlToolbar)
	ON_UPDATE_COMMAND_UI(ID_TOGGLE_HTML_TOOLBAR, OnUpdateToggleHtmlToolbar)
	ON_COMMAND(ID_TOGGLE_DISPLAY_TOOLBAR, OnToggleDisplayToolbar)
	ON_UPDATE_COMMAND_UI(ID_TOGGLE_DISPLAY_TOOLBAR, OnUpdateToggleDisplayToolbar)
	ON_COMMAND(ID_TOGGLE_LOCATE_TOOLBAR, OnToggleLocateToolbar)
	ON_UPDATE_COMMAND_UI(ID_TOGGLE_LOCATE_TOOLBAR, OnUpdateToggleLocateToolbar)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,
	// status line indicator
	ID_INDICATOR_COLOR,
	ID_INDICATOR_IS_UNIX,
	ID_INDICATOR_LINE_CNT,
	ID_INDICATOR_FILE_SIZE,
	ID_INDICATOR_POSITION,
	ID_INDICATOR_BOOK_MARKS,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
//	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_bFirstTime = TRUE;
	m_printOrientation = AfxGetApp()->GetProfileInt(printer, orientation, DFLT_PRINT_ORIENTATION);
	m_printPaperSize   = AfxGetApp()->GetProfileInt(printer, paperSize, DFLT_PAPER_SIZE);

	// defaults for page setup dlg
	m_pageSetupDialog.m_psd.Flags |= (PSD_MARGINS | PSD_INTHOUSANDTHSOFINCHES | PSD_MINMARGINS);
	// get printer margins from environment
	CString aStr;
	// set up defaults in case not in environment
	aStr.Format(_T("%6d%6d%6d%6d"), (long)(DFLT_LEFT_MARGIN   * 1000), 
									(long)(DFLT_TOP_MARGIN    * 1000),
									(long)(DFLT_RIGHT_MARGIN  * 1000),
									(long)(DFLT_BOTTOM_MARGIN * 1000));

	aStr = AfxGetApp()->GetProfileString(printer, margins, aStr);
	// initial printer page margins
	RECT * pRt  = &(m_pageSetupDialog.m_psd.rtMargin);
	pRt->left   = atoi(aStr);
	pRt->top    = atoi(aStr.Mid(6));
	pRt->right  = atoi(aStr.Mid(12));
	pRt->bottom = atoi(aStr.Mid(18));
}

CMainFrame::~CMainFrame()
{
	// set printer orientation to environment
	LPDEVMODE pDevMode = m_pageSetupDialog.GetDevMode();
	if(pDevMode)
	{
		m_printOrientation = pDevMode->dmOrientation;
		m_printPaperSize   = pDevMode->dmPaperSize;
	}

	AfxGetApp()->WriteProfileInt(printer, orientation, m_printOrientation);
	AfxGetApp()->WriteProfileInt(printer, paperSize, m_printPaperSize);

	// put printer margins into environment
	CString aStr;
	RECT * pRt = &(m_pageSetupDialog.m_psd.rtMargin);
	aStr.Format("%6d%6d%6d%6d", pRt->left, pRt->top, pRt->right, pRt->bottom);
	AfxGetApp()->WriteProfileString(printer, margins, aStr);
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC, CRect(0, 0, 0, 0), AFX_IDW_TOOLBAR) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	if (!m_htmlToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC, CRect(0, 0, 0, 0), ID_HTML_TOOLBAR) ||
		!m_htmlToolBar.LoadToolBar(IDR_HTML))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	m_htmlToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_htmlToolBar);
	
	
	if (!m_displayToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC, CRect(0, 0, 0, 0), ID_OPTIONS_TOOLBAR) ||
		!m_displayToolBar.LoadToolBar(IDR_OPTIONS))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	m_displayToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_displayToolBar);

	if (!m_locateToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC, CRect(0, 0, 0, 0), ID_LOCATE_TOOLBAR) ||
		!m_locateToolBar.LoadToolBar(IDR_LOCATE))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	m_locateToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_locateToolBar);

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::ActivateFrame(int nCmdShow) 
{
	if (m_bFirstTime) // do just one time at initilial startup
	{
		m_bFirstTime = FALSE;
	
		CString strText; // main window position
		strText = AfxGetApp()->GetProfileString(s_profileHeading, s_profileRect, NULL);

		CRect rect(0, 0, 0, 0);

		// get window position from registry
		if (!strText.IsEmpty() && 4 == sscanf(strText, _T("%d %d %d %d"), &rect.left, &rect.top, &rect.right, &rect.bottom)) 
		{
			BOOL bMaximized = AfxGetApp()->GetProfileInt(s_profileHeading, s_profileMax, 0); 
			UINT flags = bMaximized ? WPF_RESTORETOMAXIMIZED : WPF_SETMINPOSITION;

			BOOL bIconic = AfxGetApp()->GetProfileInt(s_profileHeading, s_profileIcon, 0);
			if (bIconic) 
			{
				nCmdShow = SW_SHOWMINNOACTIVE;
			}
			else
			{
				nCmdShow = bMaximized ? SW_SHOWMAXIMIZED : SW_NORMAL;
			}

			WINDOWPLACEMENT wndpl;
			wndpl.length = sizeof(WINDOWPLACEMENT);
			wndpl.showCmd = nCmdShow;
			wndpl.flags = flags;
			wndpl.ptMinPosition = CPoint(0, 0);
			wndpl.ptMaxPosition = CPoint(-::GetSystemMetrics(SM_CXBORDER), -::GetSystemMetrics(SM_CYBORDER));
			wndpl.rcNormalPosition = rect;
			LoadBarState(AfxGetApp()->m_pszProfileName);
			// sets window's position and minimized/maximized status
			SetWindowPlacement(&wndpl);

			return;
		}
	}
	
	
	CFrameWnd::ActivateFrame(nCmdShow);
}

void CMainFrame::OnDestroy() 
{
	CString strText;
	BOOL bIconic, bMaximized;

	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(WINDOWPLACEMENT);
	// gets current window position and
	//  iconized/maximized status
	BOOL bRet = GetWindowPlacement(&wndpl);
	if (wndpl.showCmd == SW_SHOWNORMAL) 
	{
		bIconic = FALSE;
		bMaximized = FALSE;
	}
	else if (wndpl.showCmd == SW_SHOWMAXIMIZED) 
	{
		bIconic = FALSE;
		bMaximized = TRUE;
	} 
	else if (wndpl.showCmd == SW_SHOWMINIMIZED) 
	{
		bIconic = TRUE;
		if (wndpl.flags) 
		{
			bMaximized = TRUE;
		}
		else 
		{
			bMaximized = FALSE;
		}
	}
	// main window location
	strText.Format("%04d %04d %04d %04d",
	               wndpl.rcNormalPosition.left,
	               wndpl.rcNormalPosition.top,
	               wndpl.rcNormalPosition.right,
	               wndpl.rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString(s_profileHeading, s_profileRect, strText);

	AfxGetApp()->WriteProfileInt(s_profileHeading,
	                             s_profileIcon, bIconic);
	AfxGetApp()->WriteProfileInt(s_profileHeading,
	                             s_profileMax, bMaximized);
	SaveBarState(AfxGetApp()->m_pszProfileName);

	
	CFrameWnd::OnDestroy();
}


void CMainFrame::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	// TODO: Add your message handler code here and/or call default
	
	CFrameWnd::OnGetMinMaxInfo(lpMMI);

	CCleanUpHTMLView * pView = (CCleanUpHTMLView *)GetActiveView();

	if(pView)
	{
		CRect clientRect;
		pView->GetClientRect(&clientRect);

		CRect windowRect;
		GetWindowRect(&windowRect);

		int nWidthOverhead = windowRect.Width() - clientRect.Width();
		int nHeightOverhead = windowRect.Height() - clientRect.Height();

		int xMin = MIN_WIDTH_IN_CHAR * pView->m_charWidth + 2;
		int yMin = MIN_HEIGHT_IN_CHAR * pView->m_charHeight + 2; 	

		lpMMI->ptMinTrackSize.x = xMin + nWidthOverhead;
		lpMMI->ptMinTrackSize.y = yMin + nHeightOverhead;
	}
}

void CMainFrame::OnFilePageSetup() 
{
	LPDEVMODE pDevMode = m_pageSetupDialog.GetDevMode();

	if(!pDevMode)
	{
		// initial devmode setup
		CWaitCursor wait;
		m_pageSetupDialog.m_psd.Flags |= PSD_RETURNDEFAULT;
		m_pageSetupDialog.DoModal();
		m_pageSetupDialog.m_psd.Flags &= ~PSD_RETURNDEFAULT;
		pDevMode = m_pageSetupDialog.GetDevMode();
	}
	
	if(pDevMode)	// pointer changes to DevMode after DoModal
	{
		pDevMode->dmOrientation = m_printOrientation;
		pDevMode->dmPaperSize = m_printPaperSize;
		::GlobalUnlock(m_pageSetupDialog.m_psd.hDevMode);

		if(IDOK == m_pageSetupDialog.DoModal())
		{
			pDevMode = m_pageSetupDialog.GetDevMode();
			m_printOrientation = pDevMode->dmOrientation;
			m_printPaperSize = pDevMode->dmPaperSize;
			::GlobalUnlock(m_pageSetupDialog.m_psd.hDevMode);
		}
	}
}

void CMainFrame::OnNewEditor() 
{
	CString procStr(_T("DicksEditor - Open New Editor"));
	// see if a file is hilighted
	CString pathStr;
	CCleanUpHTMLView * pView = (CCleanUpHTMLView *)GetActiveView();
	pView->GetSelectedText(pathStr);

	if(!pathStr.IsEmpty())
	{
		// replace all '/' with '\'
		int len = pathStr.GetLength();

		for(int i = 0; i < len; i++)
		{
			if(pathStr[i] == _T('/'))
			{
				pathStr.SetAt(i, _T('\\'));
			}
		}
		// is path relative of full ?
		char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT ];
		_splitpath(pathStr, drive, dir, fname, ext);

		if(drive[0] == _T('\0')) // has only relative path
		{
			CString dirStr = pView->GetDocument()->GetPathName();
			dirStr = dirStr.Left(dirStr.ReverseFind('\\') + 1);
			pathStr = dirStr + pathStr;
		}

		WIN32_FIND_DATA fd;
		// check for valid path
		if(INVALID_HANDLE_VALUE == FindFirstFile(pathStr, &fd))
		{
			CString aStr = GetLastErrorMessage();
			aStr += _T("\n\nOpen a new DicksEditor anyway?");

			if(IDNO == MessageBox(aStr, procStr,  MB_ICONWARNING | MB_YESNO | MB_DEFBUTTON2))
			{
				return;
			}

			pathStr.Empty();
		}
		else
		{
			pathStr = _T("\"") + pathStr + _T("\"");
		}
	}

	OpenNewEditor(pathStr, procStr);
}

BOOL CMainFrame::OpenNewEditor(CString & cmndLineStr, CString & procStr)
{
	BOOL bRetVal = TRUE;
	// get current window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(WINDOWPLACEMENT);
	// get registry window status
	CString strText; // main window position
	strText = AfxGetApp()->GetProfileString(s_profileHeading, s_profileRect, NULL);
	// gets current window position and
	if(!strText.IsEmpty() && GetWindowPlacement(&wndpl))
	{
		CDC * pDc = GetDC();
		ASSERT(pDc);
		int width  = pDc->GetDeviceCaps(HORZRES),
			height = pDc->GetDeviceCaps(VERTRES);
		ReleaseDC(pDc);

		// displace this apps main window 
		int newL = wndpl.rcNormalPosition.left + NEW_APP_DISPLACEMENT,
			newT = wndpl.rcNormalPosition.top + NEW_APP_DISPLACEMENT,
			newR = wndpl.rcNormalPosition.right + NEW_APP_DISPLACEMENT,
			newB = wndpl.rcNormalPosition.bottom + NEW_APP_DISPLACEMENT;

		// keep it on screen
		if(newT > height * 2 / 3)
		{
			newT -= 2 * NEW_APP_DISPLACEMENT;
			newB -= 2 * NEW_APP_DISPLACEMENT;
		}

		if(wndpl.rcNormalPosition.left < width && newL > width * 2 / 3 || // probably a single monitor
		   wndpl.rcNormalPosition.left >= width && newL > width * 4 / 3) // dual monitor
		{
			newL -= 2 * NEW_APP_DISPLACEMENT;
			newR -= 2 * NEW_APP_DISPLACEMENT;
		}

		CString strNewText;
		strNewText.Format("%04d %04d %04d %04d", newL, newT, newR, newB);

		// temporarly put window position in the registry 
		AfxGetApp()->WriteProfileString(s_profileHeading, s_profileRect, strNewText);

		// start the new DicksEditor at the displaced position
		CString runStr;
		GetModuleFileName(NULL, runStr.GetBuffer(_MAX_PATH), _MAX_PATH);
		runStr.ReleaseBuffer();

		runStr = runStr + _T(" ") + cmndLineStr;

		if(::WinExec(runStr, SW_SHOW) <= 31)
		{
			MessageBox(GetLastErrorMessage(), procStr, MB_ICONERROR);
			bRetVal = FALSE;
		}

		// restore registry
		AfxGetApp()->WriteProfileString(s_profileHeading, s_profileRect, strText);
	}
	else
	{
		MessageBox("Problem determining window position", procStr, MB_ICONERROR);
		bRetVal = FALSE;
	}
	
	return bRetVal;
}

void CMainFrame::OnToggleHtmlToolbar() 
{
	ShowControlBar(&m_htmlToolBar, !((m_htmlToolBar.GetStyle() & WS_VISIBLE) == WS_VISIBLE), FALSE);	
}

void CMainFrame::OnUpdateToggleHtmlToolbar(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_htmlToolBar.GetStyle() & WS_VISIBLE);	
}

void CMainFrame::OnToggleDisplayToolbar() 
{
	ShowControlBar(&m_displayToolBar, !((m_displayToolBar.GetStyle() & WS_VISIBLE) == WS_VISIBLE), FALSE);	
}

void CMainFrame::OnUpdateToggleDisplayToolbar(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_displayToolBar.GetStyle() & WS_VISIBLE);	
}

void CMainFrame::OnToggleLocateToolbar() 
{
	ShowControlBar(&m_locateToolBar, !((m_locateToolBar.GetStyle() & WS_VISIBLE) == WS_VISIBLE), FALSE);	
}

void CMainFrame::OnUpdateToggleLocateToolbar(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_locateToolBar.GetStyle() & WS_VISIBLE);	
}
