#ifndef MY_STUFF_H
#define MY_STUFF_H

#include "MainFrm.h"

#define NUM_ELEMENTS(x) (sizeof(x)/sizeof(x[0]))

LONG GetRegKey(HKEY key, LPCTSTR subkey, LPTSTR retdata);

// ASCII compatibility check
#define MAX_NUM_BAD_CHARS_IN_MESSAGE_BOX 25

// EkCreateProgressBar: function implementation
#define NUM_PROGRESS_SEGMENTS 20	// number of segments in a fluu length progress bar

// case independent strstr
char * stristr(const char *szStringToBeSearched, const char * szSubstringToSearchFor);

// browse for folders
BOOL BrowseFolders(HWND hwnd, LPSTR lpszFolder, LPSTR lpszTitle);

// find in files
int FindInFolder(CString & folderStr, CString & fileStr, CString & findWhatStr, 
				  CString & resultStr, CString & msgStr, BOOL bMatchCase, BOOL bMatchWhole);

//Errors
CString GetLastErrorMessage();
 
BOOL EkCreateProgressBar(CProgressCtrl* pProgressCtrl,
							CStatusBar* pStatusBar,
							LPCTSTR szMessage = NULL,
							int nPaneIndex = 0,
							int cxMargin = 10,
							int cxMaxWidth = -1,
							UINT nIDControl = 1);

// number files whose states can be restore
#define MAX_FILES_STATES_TO_RESTORE 25
const char * const FILENAME_WITH_RESTORE_STATES = _T("DicksEditorFileStatus.txt");
// clip board stuff

BOOL PutStrOnClipBoard(char * cBuf);
BOOL PutStrOnClipBoard(CString & aStr);
BOOL GetStrOnClipBoard(CString & aStr);
CString AddCRtoLF(CString & aStr);
// printer stuff
void EkChangePrintingOrientation( CDC* pDC, CPrintInfo* pInfo, short NewOrientation);
void EkChangePrintingPaperSize( CDC* pDC, CPrintInfo* pInfo, short NewPaperSize );

#define DFLT_PAPER_SIZE DMPAPER_LETTER
#define DFLT_PRINT_ORIENTATION DMORIENT_PORTRAIT	// DMORIENT_LANDSCAPE
#define DFLT_LEFT_MARGIN 0.75	// inches
#define DFLT_TOP_MARGIN 0.75
#define DFLT_RIGHT_MARGIN 0.5
#define DFLT_BOTTOM_MARGIN 0.5
const char * const printer		= _T("printer");
const char * const orientation	= _T("orientation");
const char * const margins		= _T("margins");
const char * const paperSize	= _T("paperSize");
const char * const bPrinterLineNum	= _T("bPrinterLineNum");

template <class T> inline void Swap(T (& a), T (& b)) {T temp; temp = a; a = b; b = temp;}

// get the length of a file
int FileSize( const char * szFileName); 

// setup progress control macro
#define PROGRESS(max, step, message) CWaitCursor wait;\
				 CProgressCtrl aProgerssCtrl;\
				 CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();\
				 ::EkCreateProgressBar(&aProgerssCtrl, &(pMainFrame->m_wndStatusBar), message, -1);\
				 aProgerssCtrl.SetRange32(0, max);\
				 aProgerssCtrl.SetStep(step);

//undo redo stuff
#define UNDO_GROW_BY 100
#define TIMEOUT_REPEAT_OPER 100 // milliseconds

//Message stuff
#define READY_MSG() ((CMainFrame *)AfxGetMainWnd())->PostMessage(WM_SETMESSAGESTRING, (WPARAM)AFX_IDS_IDLEMESSAGE, 0);
#define NUM_COARSE_PROGRESS_STEPS 20

#define MARGIN 20

enum {REPLACE = FALSE, FIND = TRUE};
enum {REVERSE = FALSE, FORWARD = TRUE};
enum {NOMATCHCASE = 0, MATCHCASE = 1};
enum {NOWHOLEWORD = 0, WHOLEWORD = 1};
enum {PITCH_FIXED = 0, PITCH_VARIABLE = 1};

#define MAX_SIZE_RING_CLIP_BD_ARRAY 10
#define NEW_APP_DISPLACEMENT 40 // pixels
#define HEX_CHAR_PER_ROW 10
#define MAX_HEX_CHAR (HEX_CHAR_PER_ROW * 10)
#define MAX_NUM_TAGS_TO_DISPLAY 30
#define MIN_WIDTH_IN_CHAR 10
#define MIN_HEIGHT_IN_CHAR 1
#define MAX_NUM_COMBO_BOX_FIND_STR 10
#define DIALOG_UNITS_PER_CHAR 4 // dialog units
#define DFLT_TAB_CHARS 4
#define MAX_CHAR_PER_TAB_STOP 20
#define OSB _T("Opportunities in Small Business")
#define DFLT_FIXED_FONT _T("Courier New")
#define MY_EMAIL_URL "dick@dickinsonian.com"
#define SUBJECT "?subject=Concerning your program DicksEditor"
#define MAIL2 "mailto:"
#define OPEN_TEMP_FILE_TRYS 100
#define WM_UPDATE_LINE_NUMS (WM_USER + 5) // skip first 5 messages
#define WM_MARK_ALL_LIKE_TEXT (WM_USER + 6)
#define WM_FORCE_CRLF_ON_LOAD (WM_USER + 7)
#define WM_FIND_MARK_RETURN (WM_USER + 8)
#define WM_MY_FIND_NEXT (WM_USER + 9)
#define WM_OPEN_MSG (WM_USER + 10)

// some colors
#define RED			RGB(255, 0 , 0)
#define GREEN		RGB(0, 128, 0)
#define BLUE		RGB(0, 0, 255)
#define BLACK		RGB(0, 0, 0)
#define MAGENTA		RGB(255, 0, 255)
#define YELLOW		RGB(255, 255, 0)
#define CYAN		RGB(0, 255, 255)
#define WHITE		RGB(255, 255, 255)
#define GRAY		RGB(128, 128, 128)
#define LT_GRAY		RGB(196, 196, 196)
#define DIM_RED		RGB(196, 92, 92)
#define LT_BLUE 	RGB(196, 196, 255)
#define LT_LT_GRAY  RGB(225, 225, 225)

char const * const Colors[] = {_T("red"),   _T("orange"), _T("yellow"), _T("green"), 
							   _T("blue"),  _T("aqua"),   _T("black"),  _T("fuchsia"), 
							   _T("gray"),  _T("lime"),   _T("maroon"), _T("navy"), 
							   _T("olive"), _T("purple"), _T("silver"), _T("teal"), 
							   _T("white")};

char const * const rgbColors[] = {_T("#ff0000"), _T("#ff6600"), _T("#ffff00"), _T("#008000"),
								  _T("#0000ff"), _T("#00ffff"), _T("#000000"), _T("#ff00ff"),
								  _T("#808080"), _T("#00ff00"), _T("#800000"), _T("#000080"),
								  _T("#808000"), _T("#800080"), _T("#c0c0c0"), _T("#008080"),
								  _T("#ffffff")};
// HTML character codes
char const * const htmlCodesStr[] = {_T("&amp;"), _T("&quot;"), _T("&lt;"), _T("&gt;"), _T("&nbsp;")};

// column and line marking
#define COL_MARK_COLOR BLUE
#define LINE_MARK_COLOR RED

// help web documentation
const char _helpDoc[] = _T("http://dickinsonian.com/programs/DicksEditorDoc.pdf#page=1&view=fitH");
// persistant main window position
const char * const s_profileHeading	= _T("Main Window");
const char * const s_profileRect	= _T("Rect");
const char * const s_profileIcon	= _T("icon");
const char * const s_profileMax		= _T("max");
const char * const s_profileTool	= _T("tool");
const char * const s_profileStatus	= _T("status");
// persistant program registry settings
const char * const settings			= _T("Settings");
const char * const findStrs			= _T("findStrs");
const char * const nFindStrs		= _T("nFindStrs");
const char * const replaceStrs		= _T("replaceStrs");
const char * const nReplaceStrs		= _T("nReplaceStrs");
const char * const bShowLineNum		= _T("bShowLineNum");
const char * const nTabChars		= _T("nTabChars");
const char * const bWrap			= _T("bWrap");
const char * const bRestoreState    = _T("bRestoreState");
const char * const bDelTempAsap		= _T("bDelTempAsap");
const char * const dFindFlags		= _T("dFindFlags");
const char * const findStr  		= _T("findStr");
const char * const markStr  		= _T("markStr");
const char * const bReadOnly  		= _T("bReadOnly");
const char * const openDirStr		= _T("openDirStr");
const char * const saveDirStr  		= _T("saveDirStr");
const char * const bConfirm  		= _T("bConfirm");
const char * const bScrollCenter	= _T("bScrollCenter");
const char * const bRemoveCRonSave	= _T("bRemoveCRonSave");
const char * const bFindDirection	= _T("bFindDirection");
const char * const bMatchCase		= _T("bMatchCase");
const char * const bWholeWord		= _T("bWholeWord");
const char * const fontPtSize		= _T("fontPtSize");
const char * const printerPtSize	= _T("printerPtSize");
const char * const bPrinterFooter	= _T("bPrinterFooter");
const char * const bPrinterHeader	= _T("bPrinterHeader");
const char * const fontFaceName		= _T("fontFaceName");
const char * const pitchStyle		= _T("pitchStyle");
const char * const charSet			= _T("charSet");
const char * const strPathIExplorer = _T("strPathIExplorer");
const char * const strPathWinDiff	= _T("strPathWinDiff");
const char * const strPathGraphics	= _T("strPathGraphics");
const char * const strUrlHtmlHelp	= _T("strUrlHtmlHelp");
const char * const strUrlCssHelp	= _T("strUrlCsslHelp");
const char * const strUrlPhpHelp	= _T("strUrlPhpHelp");
const char * const bFifMatchCase	= _T("bFifMatchCase");
const char * const bFifMatchWhole	= _T("bFifMatchWhole");
const char * const strFifType	    = _T("strFifType");
const char * const subfolderDepth	= _T("subfolderDepth");
const char * const font_sizes[] = {"10 pt.  Smallest ", "13 pt.  Smaller", "16 pt.  Mediun", "19 pt.  Larger", "22 pt.  Largest"};
const char * const strIndicator = " *";

//font point sizes
#define DFLT_PRINTER_PT_SIZE 8
#define ALLOWED_PRINTER_PT_SIZES {6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 18, 20}

#define DFLT_ANNOT_FONT_PT_SIZE 10
#define ALLOWED_ANNOT_FONT_PT_SIZES {6, 7, 8, 9, 10, 11, 12, 14, 16, 18, 20, 22, 24, 26, 28, 30, 36, 42, 48}
int const allowedPtSize[] = ALLOWED_ANNOT_FONT_PT_SIZES;

// HTML Sctipt clock
static char const XHTML_SCRIPT_BLOCK[] =
	_T("<script type=\"text/javascript\">\r\n")
	_T("<!--\r\n")
	_T("//-->\r\n")
	_T("</script>\r\n");

static char const XHTML_STYLE_BLOCK[] =
	_T("<style type=\"text/css\" media=\"screen\">\r\n")
	_T("<!-- /* the following styles are specific to this page */\r\n")
	_T("-->\r\n")
	_T("</style>\r\n");

static char const PHP_CODE_BLOCK[] =
	_T("<?php\r\n/* place PHP code here */\r\n?>");

static char const PHP_ECHO_BLOCK[] =
	_T("echo <<<_END\r\nplace HTML here\r\n_END;\r\n");

static char const XHTML_COMMENT_BLOCK[] =
	_T("<!-- place HTML comment here -->");

// HTML DTD strings
static char const * const XHTML_DTD_STR[] = 
{
	_T("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n")
	_T("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n")
	_T("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\r\n")
	_T("\t<head>\r\n")
	_T("\t\t<title>An XHTML 1.0 Transitional standard template\r\n")
	_T("\t\t</title>\r\n")
	_T("\t\t<meta http-equiv=\"content-type\" content=\"text/html;charset=utf-8\" />\r\n")
	_T("\t\t<meta http-equiv=\"Content-Style-Type\" content=\"text/css\" />\r\n")
	_T("\t\t<meta name=\"generator\" content=\"DicksEditor\" />\r\n")
	_T("\t\t<meta name=\"author\" content=\"Your Name\" />\r\n")
	_T("\t\t<meta name=\"description\" content=\"Your Content Description\" />\r\n")
	_T("\t\t<meta name=\"keywords\" content=\"Comma Separated Key Words\" />\r\n")
	_T("\t</head>\r\n")
	_T("\t<body>\r\n")
	_T("\t\t<p>Your HTML Transitional standard content here\r\n")
	_T("\t\t</p>\r\n")
	_T("\t</body>\r\n")
	_T("</html>\r\n")
	,
	_T("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n")
	_T("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\r\n")
	_T("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\r\n")
	_T("\t<head>\r\n")
	_T("\t\t<title>An XHTML 1.0 Strict standard template\r\n")
	_T("\t\t</title>\r\n")
	_T("\t\t<meta http-equiv=\"content-type\" content=\"text/html;charset=utf-8\" />\r\n")
	_T("\t\t<meta http-equiv=\"Content-Style-Type\" content=\"text/css\" />\r\n")
	_T("\t\t<meta name=\"generator\" content=\"DicksEditor\" />\r\n")
	_T("\t\t<meta name=\"author\" content=\"Your Name\" />\r\n")
	_T("\t\t<meta name=\"description\" content=\"Your Content Description\" />\r\n")
	_T("\t\t<meta name=\"keywords\" content=\"Comma Separated Key Words\" />\r\n")
	_T("\t</head>\r\n")
	_T("\t<body>\r\n")
	_T("\t\t<p>Your HTML Strict standard content here\r\n")
	_T("\t\t</p>\r\n")
	_T("\t</body>\r\n")
	_T("</html>\r\n")
};

// CSS sample text
static char const CSS_BASIC[] =	
_T("<style type=\"text/css\" media=\"screen\">\r\n")
_T("<!-- /* the following styles are specific to this page */\r\n")
_T("body{\r\n")
_T("\tfont-family: Verdana, Helvetica, Arial, sans-serif;\r\n")
_T("\tline-height: 125%;\r\n")
_T("\twidth: 1000px;\r\n")
_T("\tmargin: 0;\r\n")
_T("\tpadding: 0;\r\n")
_T("\tfont-size: 16px;\r\n")
_T("\tcolor: black;\r\n")
_T("\tbackground-color: white;\r\n")
_T("}\r\n")
_T("a:link{\r\n")
_T("\tcolor: blue;\r\n")
_T("}\r\n")
_T("a:visited{\r\n")
_T("\tcolor: purple;\r\n")
_T("}\r\n")
_T("a:hover{\r\n")
_T("\tcolor: red;\r\n")
_T("}\r\n")
_T("a:active{ /* must follow a:hover */\r\n")
_T("\tcolor: green;\r\n")
_T("}\r\n")
_T("-->\r\n")
_T("</style>\r\n");

// next char left and right of a whole word search must be on of these characters
const char * const boundingCharStr = "\t\n\r~`!@#$%^&*()_-+=|\\}]{[\"':;?/>.<,"; 

const char * const noClosingTagStrs[] = {"link", "meta", "img", "hr", "input"}; // don't include <BR>
#define MAX_LEVELS_HTML_INDENT 30
#define FARTHEST_LOOK_AHEAD_FOR_BLANK_CHAR 50
#define STR_INDICATOR_LEN 2

struct _FIND_MARK_STRUCT_
{
	char * findStr;
	char * replaceStr;
	BOOL bMatchCase;
	BOOL bMatchWhole;
	BOOL bScrollCenter;
	int findDirection;
	UINT retVal;
	BOOL bFindReplace;
};

// timing
#define FLASH_TIMER_ID 1
#define FLASH_TIMER_TIME_MS 500
#define FLASH_TIMER_MAX_CNT 3

char const lorunIpsum[] =
_T("Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec rutrum odio sit amet ")
_T("dui commodo non pretium lorem pellentesque. In adipiscing urna a ante suscipit sed ")
_T("faucibus lorem luctus. Donec pulvinar sollicitudin ante commodo adipiscing. Nunc ")
_T("varius nulla eget nisl vestibulum pulvinar. Nullam rutrum turpis et diam laoreet ")
_T("elementum. Nullam massa mi, porttitor tempus elementum ut, iaculis congue quam. Proin ")
_T("a odio bibendum diam accumsan sodales non nec mauris. Praesent vitae magna eros, id ")
_T("suscipit mauris. Quisque ornare consectetur lobortis. Integer quis nunc libero, ")
_T("lobortis imperdiet risus. Vivamus eget justo at nisl iaculis fermentum quis vel arcu. ")
_T("In hac habitasse platea dictumst. Sed porta tincidunt sapien id iaculis.\r\n\r\nNullam ")
_T("augue magna, porttitor et eleifend eu, dictum at sem. Sed tempor, nisi eu auctor ")
_T("ultricies, tellus metus facilisis justo, vel pretium orci turpis vitae justo. Quisque ")
_T("ut lectus quis urna congue sollicitudin in vitae nulla. Quisque condimentum, purus ")
_T("eget venenatis blandit, lectus erat sodales dui, sed euismod risus lacus id sem. ")
_T("Suspendisse quis augue tortor, at egestas tortor. Phasellus posuere sagittis orci, at ")
_T("ultricies felis varius et. Proin suscipit massa in nisi consectetur nec imperdiet ")
_T("eros volutpat. Phasellus auctor turpis et ligula lobortis ultrices. Suspendisse ")
_T("aliquet dapibus metus sit amet pellentesque. Nullam laoreet turpis eget mauris ")
_T("tristique pretium. Class aptent taciti sociosqu ad litora torquent per conubia ")
_T("nostra, per inceptos himenaeos. Maecenas aliquam velit vitae dui auctor posuere. Nunc ")
_T("tempus placerat lobortis. Quisque ante felis, vulputate vitae placerat lacinia, ")
_T("accumsan non odio. Integer at est orci. Integer elementum sodales tellus semper ")
_T("hendrerit. Nullam tristique convallis justo, vel ultrices purus mattis in. Cras ut ")
_T("sagittis ipsum.\r\n\r\nInteger posuere eros ut sapien semper viverra. Curabitur laoreet ")
_T("placerat ante, sed semper ipsum laoreet in. Suspendisse massa nunc, euismod id ")
_T("convallis non, rutrum ut dui. Praesent venenatis orci vel quam faucibus aliquet. ")
_T("Pellentesque in mi nisl, pulvinar imperdiet lectus. Sed faucibus orci nec ante ")
_T("iaculis ut dictum purus laoreet. Aliquam laoreet erat ac elit porta auctor. Duis eget ")
_T("ante lectus. Nullam massa metus, ornare quis volutpat sed, aliquam ac velit. Ut eros ")
_T("justo, pulvinar ut consectetur sit amet, laoreet eget nibh. Phasellus interdum varius ")
_T("neque.\r\n\r\nCum sociis natoque penatibus et magnis dis parturient montes, nascetur ")
_T("ridiculus mus. Morbi non nunc nunc. Suspendisse potenti. Quisque viverra cursus ")
_T("volutpat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ")
_T("ridiculus mus. Curabitur at suscipit elit. Morbi congue, neque vel vulputate ") 
_T("interdum, nulla diam euismod sem, iaculis feugiat nibh magna sed urna. Fusce nec ") 
_T("mauris metus, ut pretium velit. Curabitur sed diam tortor. Nullam enim leo, ")
_T("consectetur sed mollis vitae, rutrum cursus felis. In sed dignissim tellus. ")
_T("Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis ")
_T("egestas. Ut vehicula neque non tellus mollis gravida eget nec lorem. Pellentesque ")
_T("vitae velit leo, eget luctus quam. Curabitur luctus tellus vitae sapien commodo ")
_T("tempor. Aenean elementum vehicula orci vitae consequat. Proin suscipit tempus nunc et ")
_T("porta. Integer quis elit id mauris placerat interdum at id est.\r\n\r\nFusce vehicula ")
_T("pretium elit vitae interdum. Praesent mattis, lectus vel tincidunt facilisis, justo ")
_T("quam fringilla nibh, at elementum ligula risus id risus. Ut consequat commodo ")
_T("consectetur. Quisque id ipsum est, at molestie massa. Donec ut nunc quis lacus ")
_T("posuere pharetra. Maecenas sagittis elementum tortor, et tempor augue tempus a. Morbi ")
_T("sapien arcu, sodales non vestibulum non, bibendum fermentum nisi. Fusce volutpat enim ")
_T("in mauris bibendum sit amet blandit ipsum tempor. Aliquam dapibus fringilla nulla, ")
_T("sed blandit justo condimentum sit amet. Sed vel mauris vel metus vehicula iaculis eu ")
_T("quis orci. Vestibulum ipsum arcu, cursus in porttitor eu, sagittis non turpis. Sed ac ")
_T("quam dui, vel mollis risus. Donec blandit sodales aliquam. Suspendisse fermentum, est") 
_T("eu euismod lobortis, turpis libero pharetra massa, id sodales ligula elit id orci. ")
_T("Mauris eget est dui, vitae ultrices risus. Quisque vitae velit eget velit vehicula ")
_T("placerat.");

char const ascii_html_400[] =
_T("ASCII\t\t\tHTML\tHTML\t\r\n")
_T("Dec\tHex\tSymbol\tNumber\tName\tDescription\r\n")
_T("--------------------------------------------------------")
_T("--------------------------------------------------------\r\n")
_T("32\t20\t \t&#32;\t\tspace\r\n")
_T("33\t21\t!\t&#33;\t\texclamation point\r\n")
_T("34\t22\t\"\t&#34;\t&quot;\tdouble quotes\r\n")
_T("35\t23\t#\t&#35;\t\tnumber sign\r\n")
_T("36\t24\t$\t&#36;\t\tdollar sign\r\n")
_T("37\t25\t%\t&#37;\t\tpercent sign\r\n")
_T("38\t26\t&\t&#38;\t&amp;\tampersand\r\n")
_T("39\t27\t'\t&#39;\t\tsingle quote\r\n")
_T("40\t28\t(\t&#40;\t\topening parenthesis\r\n")
_T("41\t29\t)\t&#41;\t\tclosing parenthesis\r\n")
_T("42\t2A\t*\t&#42;\t\tasterisk\r\n")
_T("43\t2B\t+\t&#43;\t\tplus sign\r\n")
_T("44\t2C\t,\t&#44;\t\tcomma\r\n")
_T("45\t2D\t-\t&#45;\t\tminus sign - hyphen\r\n")
_T("46\t2E\t.\t&#46;\t\tperiod\r\n")
_T("47\t2F\t/\t&#47;\t\tslash\r\n")
_T("48\t30\t0\t&#48;\t\tzero\r\n")
_T("49\t31\t1\t&#49;\t\tone\r\n")
_T("50\t32\t2\t&#50;\t\ttwo\r\n")
_T("51\t33\t3\t&#51;\t\tthree\r\n")
_T("52\t34\t4\t&#52;\t\tfour\r\n")
_T("53\t35\t5\t&#53;\t\tfive\r\n")
_T("54\t36\t6\t&#54;\t\tsix\r\n")
_T("55\t37\t7\t&#55;\t\tseven\r\n")
_T("56\t38\t8\t&#56;\t\teight\r\n")
_T("57\t39\t9\t&#57;\t\tnine\r\n")
_T("58\t3A\t:\t&#58;\t\tcolon\r\n")
_T("59\t3B\t;\t&#59;\t\tsemicolon\r\n")
_T("60\t3C\t<\t&#60;\t&lt;\tless than sign\r\n")
_T("61\t3D\t=\t&#61;\t\tequal sign\r\n")
_T("62\t3E\t>\t&#62;\t&gt;\tgreater than sign\r\n")
_T("63\t3F\t?\t&#63;\t\tquestion mark\r\n")
_T("64\t40\t@\t&#64;\t\tat symbol\r\n")
_T("65\t41\tA\t&#65;\t\t\r\n")
_T("66\t42\tB\t&#66;\t\t\r\n")
_T("67\t43\tC\t&#67;\t\t\r\n")
_T("68\t44\tD\t&#68;\t\t\r\n")
_T("69\t45\tE\t&#69;\t\t\r\n")
_T("70\t46\tF\t&#70;\t\t\r\n")
_T("71\t47\tG\t&#71;\t\t\r\n")
_T("72\t48\tH\t&#72;\t\t\r\n")
_T("73\t49\tI\t&#73;\t\t\r\n")
_T("74\t4A\tJ\t&#74;\t\t\r\n")
_T("75\t4B\tK\t&#75;\t\t\r\n")
_T("76\t4C\tL\t&#76;\t\t\r\n")
_T("77\t4D\tM\t&#77;\t\t\r\n")
_T("78\t4E\tN\t&#78;\t\t\r\n")
_T("79\t4F\tO\t&#79;\t\t\r\n")
_T("80\t50\tP\t&#80;\t\t\r\n")
_T("81\t51\tQ\t&#81;\t\t\r\n")
_T("82\t52\tR\t&#82;\t\t\r\n")
_T("83\t53\tS\t&#83;\t\t\r\n")
_T("84\t54\tT\t&#84;\t\t\r\n")
_T("85\t55\tU\t&#85;\t\t\r\n")
_T("86\t56\tV\t&#86;\t\t\r\n")
_T("87\t57\tW\t&#87;\t\t\r\n")
_T("88\t58\tX\t&#88;\t\t\r\n")
_T("89\t59\tY\t&#89;\t\t\r\n")
_T("90\t5A\tZ\t&#90;\t\t\r\n")
_T("91\t5B\t[\t&#91;\t\topening bracket\r\n")
_T("92\t5C\t\\\t&#92;\t\tbackslash\r\n")
_T("93\t5D\t]\t&#93;\t\tclosing bracket\r\n")
_T("94\t5E\t^\t&#94;\t\tcaret - circumflex\r\n")
_T("95\t5F\t_\t&#95;\t\tunderscore\r\n")
_T("96\t60\t`\t&#96;\t\tgrave accent\r\n")
_T("97\t61\ta\t&#97;\t\t\r\n")
_T("98\t62\tb\t&#98;\t\t\r\n")
_T("99\t63\tc\t&#99;\t\t\r\n")
_T("100\t64\td\t&#100;\t\t\r\n")
_T("101\t65\te\t&#101;\t\t\r\n")
_T("102\t66\tf\t&#102;\t\t\r\n")
_T("103\t67\tg\t&#103;\t\t\r\n")
_T("104\t68\th\t&#104;\t\t\r\n")
_T("105\t69\ti\t&#105;\t\t\r\n")
_T("106\t6A\tj\t&#106;\t\t\r\n")
_T("107\t6B\tk\t&#107;\t\t\r\n")
_T("108\t6C\tl\t&#108;\t\t\r\n")
_T("109\t6D\tm\t&#109;\t\t\r\n")
_T("110\t6E\tn\t&#110;\t\t\r\n")
_T("111\t6F\to\t&#111;\t\t\r\n")
_T("112\t70\tp\t&#112;\t\t\r\n")
_T("113\t71\tq\t&#113;\t\t\r\n")
_T("114\t72\tr\t&#114;\t\t\r\n")
_T("115\t73\ts\t&#115;\t\t\r\n")
_T("116\t74\tt\t&#116;\t\t\r\n")
_T("117\t75\tu\t&#117;\t\t\r\n")
_T("118\t76\tv\t&#118;\t\t\r\n")
_T("119\t77\tw\t&#119;\t\t\r\n")
_T("120\t78\tx\t&#120;\t\t\r\n")
_T("121\t79\ty\t&#121;\t\t\r\n")
_T("122\t7A\tz\t&#122;\t\t\r\n")
_T("123\t7B\t{\t&#123;\t\topening brace\r\n")
_T("124\t7C\t|\t&#124;\t\tvertical bar\r\n")
_T("125\t7D\t}\t&#125;\t\tclosing brace\r\n")
_T("126\t7E\t~\t&#126;\t\tequivalency sign - tilde\r\n\r\n")
_T("127 - 159    7F - 9F    not defined in HTML 4 standard\r\n\r\n")
_T("160\tA0\t\t&#160;\t&nbsp;\tnon-breaking space\r\n")
_T("161\tA1\t\t&#161;\t&iexcl;\tinverted exclamation mark\r\n")
_T("162\tA2\t\t&#162;\t&cent;\tcent sign\r\n")
_T("163\tA3\t\t&#163;\t&pound;\tpound sign\r\n")
_T("164\tA4\t\t&#164;\t&curren;\tcurrency sign\r\n")
_T("165\tA5\t\t&#165;\t&yen;\tyen sign\r\n")
_T("166\tA6\t\t&#166;\t&brvbar;\tbroken vertical bar\r\n")
_T("167\tA7\t\t&#167;\t&sect;\tsection sign\r\n")
_T("168\tA8\t\t&#168;\t&uml;\tspacing diaeresis - umlaut\r\n")
_T("169\tA9\t\t&#169;\t&copy;\tcopyright sign\r\n")
_T("170\tAA\t\t&#170;\t&ordf;\tfeminine ordinal indicator\r\n")
_T("171\tAB\t\t&#171;\t&laquo;\tleft double angle quotes\r\n")
_T("172\tAC\t\t&#172;\t&not;\tnot sign\r\n")
_T("173\tAD\t\t&#173;\t&shy;\tsoft hyphen\r\n")
_T("174\tAE\t\t&#174;\t&reg;\tregistered trade mark sign\r\n")
_T("175\tAF\t\t&#175;\t&macr;\tspacing macron - overline\r\n")
_T("176\tB0\t\t&#176;\t&deg;\tdegree sign\r\n")
_T("177\tB1\t\t&#177;\t&plusmn;\tplus-or-minus sign\r\n")
_T("178\tB2\t\t&#178;\t&sup2;\tsuperscript two - squared\r\n")
_T("179\tB3\t\t&#179;\t&sup3;\tsuperscript three - cubed\r\n")
_T("180\tB4\t\t&#180;\t&acute;\tacute accent - spacing acute\r\n")
_T("181\tB5\t\t&#181;\t&micro;\tmicro sign\r\n")
_T("182\tB6\t\t&#182;\t&para;\tpilcrow sign - paragraph sign\r\n")
_T("183\tB7\t\t&#183;\t&middot;\tmiddle dot - Georgian comma\r\n")
_T("184\tB8\t\t&#184;\t&cedil;\tspacing cedilla\r\n")
_T("185\tB9\t\t&#185;\t&sup1;\tsuperscript one\r\n")
_T("186\tBA\t\t&#186;\t&ordm;\tmasculine ordinal indicator\r\n")
_T("187\tBB\t\t&#187;\t&raquo;\tright double angle quotes\r\n")
_T("188\tBC\t\t&#188;\t&frac14;\tfraction one quarter\r\n")
_T("189\tBD\t\t&#189;\t&frac12;\tfraction one half\r\n")
_T("190\tBE\t\t&#190;\t&frac34;\tfraction three quarters\r\n")
_T("191\tBF\t\t&#191;\t&iquest;\tinverted question mark\r\n")
_T("192\tC0\t\t&#192;\t&Agrave;\tlatin capital letter A with grave\r\n")
_T("193\tC1\t\t&#193;\t&Aacute;\tlatin capital letter A with acute\r\n")
_T("194\tC2\t\t&#194;\t&Acirc;\tlatin capital letter A with circumflex\r\n")
_T("195\tC3\t\t&#195;\t&Atilde;\tlatin capital letter A with tilde\r\n")
_T("196\tC4\t\t&#196;\t&Auml;\tlatin capital letter A with diaeresis\r\n")
_T("197\tC5\t\t&#197;\t&Aring;\tlatin capital letter A with ring above\r\n")
_T("198\tC6\t\t&#198;\t&AElig;\tlatin capital letter AE\r\n")
_T("199\tC7\t\t&#199;\t&Ccedil;\tlatin capital letter C with cedilla\r\n")
_T("200\tC8\t\t&#200;\t&Egrave;\tlatin capital letter E with grave\r\n")
_T("201\tC9\t\t&#201;\t&Eacute;\tlatin capital letter E with acute\r\n")
_T("202\tCA\t\t&#202;\t&Ecirc;\tlatin capital letter E with circumflex\r\n")
_T("203\tCB\t\t&#203;\t&Euml;\tlatin capital letter E with diaeresis\r\n")
_T("204\tCC\t\t&#204;\t&Igrave;\tlatin capital letter I with grave\r\n")
_T("205\tCD\t\t&#205;\t&Iacute;\tlatin capital letter I with acute\r\n")
_T("206\tCE\t\t&#206;\t&Icirc;\tlatin capital letter I with circumflex\r\n")
_T("207\tCF\t\t&#207;\t&Iuml;\tlatin capital letter I with diaeresis\r\n")
_T("208\tD0\t\t&#208;\t&ETH;\tlatin capital letter ETH\r\n")
_T("209\tD1\t\t&#209;\t&Ntilde;\tlatin capital letter N with tilde\r\n")
_T("210\tD2\t\t&#210;\t&Ograve;\tlatin capital letter O with grave\r\n")
_T("211\tD3\t\t&#211;\t&Oacute;\tlatin capital letter O with acute\r\n")
_T("212\tD4\t\t&#212;\t&Ocirc;\tlatin capital letter O with circumflex\r\n")
_T("213\tD5\t\t&#213;\t&Otilde;\tlatin capital letter O with tilde\r\n")
_T("214\tD6\t\t&#214;\t&Ouml;\tlatin capital letter O with diaeresis\r\n")
_T("215\tD7\t\t&#215;\t&times;\tmultiplication sign\r\n")
_T("216\tD8\t\t&#216;\t&Oslash;\tlatin capital letter O with slash\r\n")
_T("217\tD9\t\t&#217;\t&Ugrave;\tlatin capital letter U with grave\r\n")
_T("218\tDA\t\t&#218;\t&Uacute;\tlatin capital letter U with acute\r\n")
_T("219\tDB\t\t&#219;\t&Ucirc;\tlatin capital letter U with circumflex\r\n")
_T("220\tDC\t\t&#220;\t&Uuml;\tlatin capital letter U with diaeresis\r\n")
_T("221\tDD\t\t&#221;\t&Yacute;\tlatin capital letter Y with acute\r\n")
_T("222\tDE\t\t&#222;\t&THORN;\tlatin capital letter THORN\r\n")
_T("223\tDF\t\t&#223;\t&szlig;\tlatin small letter sharp s - ess-zed\r\n")
_T("224\tE0\t\t&#224;\t&agrave;\tlatin small letter a with grave\r\n")
_T("225\tE1\t\t&#225;\t&aacute;\tlatin small letter a with acute\r\n")
_T("226\tE2\t\t&#226;\t&acirc;\tlatin small letter a with circumflex\r\n")
_T("227\tE3\t\t&#227;\t&atilde;\tlatin small letter a with tilde\r\n")
_T("228\tE4\t\t&#228;\t&auml;\tlatin small letter a with diaeresis\r\n")
_T("229\tE5\t\t&#229;\t&aring;\tlatin small letter a with ring above\r\n")
_T("230\tE6\t\t&#230;\t&aelig;\tlatin small letter ae\r\n")
_T("231\tE7\t\t&#231;\t&ccedil;\tlatin small letter c with cedilla\r\n")
_T("232\tE8\t\t&#232;\t&egrave;\tlatin small letter e with grave\r\n")
_T("233\tE9\t\t&#233;\t&eacute;\tlatin small letter e with acute\r\n")
_T("234\tEA\t\t&#234;\t&ecirc;\tlatin small letter e with circumflex\r\n")
_T("235\tEB\t\t&#235;\t&euml;\tlatin small letter e with diaeresis\r\n")
_T("236\tEC\t\t&#236;\t&igrave;\tlatin small letter i with grave\r\n")
_T("237\tED\t\t&#237;\t&iacute;\tlatin small letter i with acute\r\n")
_T("238\tEE\t\t&#238;\t&icirc;\tlatin small letter i with circumflex\r\n")
_T("239\tEF\t\t&#239;\t&iuml;\tlatin small letter i with diaeresis\r\n")
_T("240\tF0\t\t&#240;\t&eth;\tlatin small letter eth\r\n")
_T("241\tF1\t\t&#241;\t&ntilde;\tlatin small letter n with tilde\r\n")
_T("242\tF2\t\t&#242;\t&ograve;\tlatin small letter o with grave\r\n")
_T("243\tF3\t\t&#243;\t&oacute;\tlatin small letter o with acute\r\n")
_T("244\tF4\t\t&#244;\t&ocirc;\tlatin small letter o with circumflex\r\n")
_T("245\tF5\t\t&#245;\t&otilde;\tlatin small letter o with tilde\r\n")
_T("246\tF6\t\t&#246;\t&ouml;\tlatin small letter o with diaeresis\r\n")
_T("247\tF7\t\t&#247;\t&divide;\tdivision sign\r\n")
_T("248\tF8\t\t&#248;\t&oslash;\tlatin small letter o with slash\r\n")
_T("249\tF9\t\t&#249;\t&ugrave;\tlatin small letter u with grave\r\n")
_T("250\tFA\t\t&#250;\t&uacute;\tlatin small letter u with acute\r\n")
_T("251\tFB\t\t&#251;\t&ucirc;\tlatin small letter u with circumflex\r\n")
_T("252\tFC\t\t&#252;\t&uuml;\tlatin small letter u with diaeresis\r\n")
_T("253\tFD\t\t&#253;\t&yacute;\tlatin small letter y with acute\r\n")
_T("254\tFE\t\t&#254;\t&thorn;\tlatin small letter thorn\r\n")
_T("255\tFF\t\t&#255;\t&yuml;\tlatin small letter y with diaeresis");

class CURL
{
	private:
	CString m_strBrowser; // The default browser

	public:
	void Open(LPCTSTR lpszURL, BOOL bNewWindow = TRUE) // Open a URL
	{	
		if(bNewWindow) // show in new browser
		{
			if(::ShellExecute(NULL, NULL, GetBrowser(), lpszURL, NULL, SW_SHOWNORMAL) <= (HINSTANCE)32)
			{
				AfxMessageBox(GetLastErrorMessage(), MB_ICONWARNING);
			}
		}
		else // show in a new browser tab
		{
			if(::ShellExecute(NULL, NULL, lpszURL, NULL, NULL, SW_SHOWNORMAL) <= (HINSTANCE)32)
			{
				AfxMessageBox(GetLastErrorMessage(), MB_ICONWARNING);
			}
		}
	}

	// Get the default browser from the registry
	LPCTSTR GetBrowser(void)
	{
		// Have we already got the browser?
		if(m_strBrowser.IsEmpty())
		{
			// Get the default browser from HKCR\http\shell\open\command
			HKEY hKey = NULL;
			// Open the registry
			if(::RegOpenKeyEx(HKEY_CLASSES_ROOT, _T("http\\shell\\open\\command"), 0, KEY_READ, &hKey) == ERROR_SUCCESS)
			{
				// Data size
				DWORD cbData = 0;
				// Get the default value
				if(::RegQueryValueEx(hKey, NULL, NULL, NULL, NULL, &cbData) == ERROR_SUCCESS && cbData > 0)
				{
					// Allocate a suitable buffer
					TCHAR* psz = new TCHAR [cbData];
					// Success?
					if (psz != NULL)
					{
						if (::RegQueryValueEx(hKey, NULL, NULL, NULL, (LPBYTE)psz, &cbData) == ERROR_SUCCESS)
						{
						   // Success!
						   m_strBrowser = psz;
						}

						delete [] psz;
					}
				}

				::RegCloseKey(hKey);
			}
			// Do we have the browser?
			if (m_strBrowser.GetLength() > 0)
			{
				// Strip the full path from the string
				int nStart = m_strBrowser.Find('"');
				int nEnd = m_strBrowser.ReverseFind('"');
				// Do we have either quote?
				// If so, then the path contains spaces
				if (nStart >= 0 && nEnd >= 0)
				{
					 // Are they the same?
					 if (nStart != nEnd)
					 {   
						// Get the full path
						m_strBrowser = m_strBrowser.Mid(nStart + 1, nEnd - nStart - 1);
					}
				}
				else
				{
					 // We may have a pathname with spaces but
					 // no quotes (Netscape), e.g.:
					 //   C:\PROGRAM FILES\NETSCAPE\COMMUNICATOR\PROGRAM\NETSCAPE.EXE -h "%1"
					 // Look for the last backslash
					 int nIndex = m_strBrowser.ReverseFind('\\');
					 // Success?
					 if (nIndex > 0)
					{
						// Look for the next space after the final
						// backslash
						int nSpace = m_strBrowser.Find(' ', nIndex);
						// Do we have a space?
						if (nSpace > 0)
						{
							m_strBrowser = m_strBrowser.Left(nSpace);
						}
					}
				}
			}
		}

		return m_strBrowser;
	}
}; // class CURL

#endif 
