// SettingsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingsDlg dialog


CSettingsDlg::CSettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSettingsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSettingsDlg)
	m_bShowLineNum = FALSE;
	m_bReadOnly = FALSE;
	m_bWrap = FALSE;
	m_bScrollCenter = FALSE;
	m_bConfirm = FALSE;
	m_tabCharsString = _T("");
	m_bMarkStrings = FALSE;
	m_pitchStyle = -1;
	m_charSet = 0; // 0 = ANSI_CHARSET, 1 = DEFAULT_CHARSET (all fonts), 2 = SYMBOL_CHARSET, 255 OEM_CHARSET
	m_bIsUnix = FALSE;
	m_bPrintFooter = FALSE;
	m_bPrintHeader = FALSE;
	m_bPrinterLineNum = FALSE;
	m_strPathIExplorer = _T("");
	m_strPathWinDiff = _T("");
	m_mruCount = 0;
	m_strPathGraphics = _T("");
	m_strUrlHtmlHelp = _T("");
	m_strUrlCssHelp = _T("");
	m_strUrlPhpHelp = _T("");
	m_bDelTempAsap = FALSE;
	m_bRestoreState = FALSE;
	//}}AFX_DATA_INIT
	m_fontPtSize = DFLT_ANNOT_FONT_PT_SIZE;
	m_printerPtSize = DFLT_PRINTER_PT_SIZE;
	m_pFont = NULL;
}


void CSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingsDlg)
	DDX_Control(pDX, IDC_COMBO_PRINTER_SIZE, m_comboBoxPrinterSize);
	DDX_Control(pDX, IDC_COMBO_FONT_SIZE, m_comboBoxFontSize);
	DDX_Control(pDX, IDC_COMBO_FONT_NAME, m_comboBoxFontName);
	DDX_Check(pDX, IDC_CHECK_LINE_NOS, m_bShowLineNum);
	DDX_Check(pDX, IDC_CHECK_READ_ONLY, m_bReadOnly);
	DDX_Check(pDX, IDC_CHECK_WORD_WRAP, m_bWrap);
	DDX_Check(pDX, IDC_CHECK_SCROLL_2_CENTER, m_bScrollCenter);
	DDX_Check(pDX, IDC_CHECK_CONFIRM, m_bConfirm);
	DDX_CBString(pDX, IDC_COMBO_TAB_STOPS, m_tabCharsString);
	DDX_Check(pDX, IDC_MARK_TEXT, m_bMarkStrings);
	DDX_Radio(pDX, IDC_RADIO1_PITCH, m_pitchStyle);
	DDX_Radio(pDX, IDC_RADIO1_CHAR_SET, m_charSet);
	DDX_Check(pDX, IDC_CHECK_SAVE_AS_UNIX, m_bIsUnix);
	DDX_Check(pDX, IDC_CHECK_PAGE_NUM, m_bPrintFooter);
	DDX_Check(pDX, IDC_CHECK_FILE_NAME, m_bPrintHeader);
	DDX_Check(pDX, IDC_CHECK_PRN_LINE_NUM, m_bPrinterLineNum);
	DDX_Text(pDX, IDC_EDIT_IEXPLORER, m_strPathIExplorer);
	DDX_Text(pDX, IDC_EDIT_WINDIFF, m_strPathWinDiff);
	DDX_Text(pDX, IDC_EDIT_MRU, m_mruCount);
	DDX_Text(pDX, IDC_EDIT_GRAPHICS, m_strPathGraphics);
	DDX_Text(pDX, IDC_EDIT_WEB_HTML, m_strUrlHtmlHelp);
	DDX_Text(pDX, IDC_EDIT_WEB_CSS, m_strUrlCssHelp);
	DDX_Text(pDX, IDC_EDIT_PHP_CSS, m_strUrlPhpHelp);
	DDX_Check(pDX, IDC_CHECK_DEL_TEMP_ASAP, m_bDelTempAsap);
	DDX_Check(pDX, IDC_RESTORE_STATE, m_bRestoreState);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingsDlg, CDialog)
	//{{AFX_MSG_MAP(CSettingsDlg)
	ON_BN_CLICKED(IDC_RADIO1_PITCH, OnPitch)
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_COMBO_FONT_NAME, OnSelchangeComboFontName)
	ON_BN_CLICKED(IDC_BUTTON_IEXPLORER, OnButtonIexplorer)
	ON_BN_CLICKED(IDC_BUTTON_WINDIFF, OnButtonWindiff)
	ON_BN_CLICKED(IDC_RADIO2_PITCH, OnPitch)
	ON_BN_CLICKED(IDC_RADIO2_CHAR_SET, OnPitch)
	ON_BN_CLICKED(IDC_RADIO1_CHAR_SET, OnPitch)
	ON_BN_CLICKED(IDC_RADIO3_CHAR_SET, OnPitch)
	ON_BN_CLICKED(IDC_RADIO4_CHAR_SET, OnPitch)
	ON_BN_CLICKED(IDC_BUTTON_GRAPHICS, OnButtonGraphics)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

const int const allowedAnnotFontPtSizes[] = ALLOWED_ANNOT_FONT_PT_SIZES;
const int const allowedPrinterFontPtSizes[] = ALLOWED_PRINTER_PT_SIZES;

// START font enum call back handler
struct _enum_proc_
{
	int pitchStyle;
	int numFonts;
	CComboBox * pComboBox;
	BYTE charSet;
};

int CALLBACK EnumFontFamExProc(ENUMLOGFONTEX *lpelfe, NEWTEXTMETRIC *lpntm, int nFontType, LPARAM lParam)
{
	int & pitchStyle = ((_enum_proc_ *)lParam)->pitchStyle;
	int & pNumFonts  = ((_enum_proc_ *)lParam)->numFonts;
	CComboBox * pCB  = ((_enum_proc_ *)lParam)->pComboBox;
	BYTE & charSet   = ((_enum_proc_ *)lParam)->charSet;

	// DEFAULT_CHARSET means all fonts
	if((lpntm->tmPitchAndFamily  & 1) == pitchStyle && (charSet == DEFAULT_CHARSET || lpntm->tmCharSet == charSet)) // zero order bit = 1 for variable pitch
	{
		if(pCB->FindString(-1, lpelfe->elfLogFont.lfFaceName) < 0) 
		{
			pCB->AddString(lpelfe->elfLogFont.lfFaceName);
			pNumFonts++;
		}
	}

	return 1;
}
// END font enum call back handler

BOOL CSettingsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString aStr;

	// fill out printer font size combo box
	for(int nSel = -1, i = 0; i < NUM_ELEMENTS(allowedPrinterFontPtSizes); i++)
	{
		aStr.Format(_T("%d"), allowedPrinterFontPtSizes[i]);
		m_comboBoxPrinterSize.AddString(aStr);

		if(m_printerPtSize == allowedPrinterFontPtSizes[i])
		{
			nSel = i;
		}
	}

	m_comboBoxPrinterSize.SetCurSel(nSel);


	// fill out font size combo box
	for(nSel = -1, i = 0; i < NUM_ELEMENTS(allowedAnnotFontPtSizes); i++)
	{
		aStr.Format(_T("%d"), allowedAnnotFontPtSizes[i]);
		m_comboBoxFontSize.AddString(aStr);

		if(m_fontPtSize == allowedAnnotFontPtSizes[i])
		{
			nSel = i;
		}
	}

	m_comboBoxFontSize.SetCurSel(nSel);

	// fill our font face name combo box
	OnPitch();
		
	WINDOWPLACEMENT wp;
	CWnd * pWnd = (CWnd *) GetDlgItem(IDC_MARK_TEXT);
	pWnd->EnableWindow(!m_markStr.IsEmpty());
	
	// restore dialog to last used position or center if first time and
	// close up the dialog window if necessary
	GetWindowPlacement(&wp);
	SetWindowPos(NULL, m_posSettingsDlg.x, m_posSettingsDlg.y, 
					   ((CRect)wp.rcNormalPosition).Width(), ((CRect)wp.rcNormalPosition).Height(), 
						SWP_NOZORDER);

	SetSample();
	UpdateStaticText();

	return TRUE;
}

void CSettingsDlg::OnOK() 
{
	// get font point size
	CString aStr;

	m_comboBoxFontSize.GetWindowText(aStr);
	m_fontPtSize = ::atoi(aStr);

	m_comboBoxPrinterSize.GetWindowText(aStr);
	m_printerPtSize = ::atoi(aStr);

	// get font face name
	m_comboBoxFontName.GetWindowText(m_fontFaceName);

	SaveWindowPos();
	CDialog::OnOK();
}

void CSettingsDlg::OnPitch() 
{
	UpdateData(TRUE);

	// fill our font face name combo box
	LOGFONT lf = {0};
	int charSet = m_charSet <= 2 ? m_charSet : OEM_CHARSET;
//	lf.lfCharSet = charSet;
	lf.lfCharSet = DEFAULT_CHARSET;
	lf.lfFaceName[0] = '\0';

	_enum_proc_ ep = {m_pitchStyle, 0, &m_comboBoxFontName, charSet};

	m_comboBoxFontName.ResetContent();
	// fill out combox list strings
	::EnumFontFamiliesEx(m_pViewDC->m_hDC, &lf, (FONTENUMPROC) EnumFontFamExProc, (LPARAM)(&ep), 0);
	// show count of fonts found
	CString aStr;
	aStr.Format("%d fonts", ep.numFonts);
	SetDlgItemText(IDC_STATIC_N_FONTS, aStr);
	// current face name being used
	m_comboBoxFontName.SetWindowText(m_fontFaceName);
}

void CSettingsDlg::OnClose() 
{	
	OnCancel(); 
}

void CSettingsDlg::OnCancel() 
{
	SaveWindowPos();
	CDialog::OnCancel();
}

void CSettingsDlg::SaveWindowPos()
{
	WINDOWPLACEMENT wp;
	GetWindowPlacement(&wp);
	CPoint aPt = ((CRect)wp.rcNormalPosition).TopLeft();
	m_posSettingsDlg = aPt;
	delete m_pFont;
}

static pFont = NULL;

void CSettingsDlg::SetSample()
{
	CString aStr;
	m_comboBoxFontName.GetWindowText(aStr);

	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EDIT_SAMPLE);
	CDC * pDc = pEdit->GetDC();
	ASSERT(pDc);
	delete m_pFont;
	m_pFont = new CFont;
	m_pFont->CreatePointFont(10 * 12, m_fontFaceName, pDc);
	pEdit->SetFont(m_pFont, TRUE);
	pEdit->SetWindowText("12345678901234567890123456\r\n"
						 "ABCDEFGHIJKLMNOPQRSTUVWXYZ\r\n"
						 "abcdefghijklmnopqrstuvwxyz");

	CFont * pOldFont = pDc->SelectObject(m_pFont);
	TEXTMETRIC tm;
	pDc->GetTextMetrics(&tm);
	int charHeight = tm.tmHeight;
	int charWidth = tm.tmAveCharWidth;
	pDc->SelectObject(pOldFont);
	pEdit->ReleaseDC(pDc);
	TRACE2("FONT W %d H %d\n", charWidth, charHeight);  
}

const char const IExploreExeFileTitle[] = "Select Internet Browser Program";
const char const WinDiffExeFileTitle[] = "Select File Differencing Peogram";
const char * const openFilter = "Executable Files ( *.exe )|*.exe|"
								 "All Files ( *.* )|*.*||";

const UINT openFlags   = OFN_EXPLORER | OFN_ENABLESIZING | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;

void CSettingsDlg::OnSelchangeComboFontName() 
{
	m_comboBoxFontName.GetLBText(m_comboBoxFontName.GetCurSel(), m_fontFaceName);
	SetSample();	
}

void CSettingsDlg::OnButtonIexplorer() 
{
	UpdateData(TRUE);
	CString aStr =  GetExeFilePathName(IExploreExeFileTitle, m_strPathIExplorer);
	if(!aStr.IsEmpty()) m_strPathIExplorer = aStr;
	UpdateStaticText();
	UpdateData(FALSE);
}

void CSettingsDlg::OnButtonWindiff() 
{
	UpdateData(TRUE);
	CString aStr =  GetExeFilePathName(WinDiffExeFileTitle, m_strPathWinDiff);
	if(!aStr.IsEmpty()) m_strPathWinDiff = aStr;
	UpdateStaticText();
	UpdateData(FALSE);
}

void CSettingsDlg::OnButtonGraphics() 
{
	UpdateData(TRUE);
	CString aStr =  GetExeFilePathName(WinDiffExeFileTitle, m_strPathGraphics);
	if(!aStr.IsEmpty()) m_strPathGraphics = aStr;
	UpdateStaticText();
	UpdateData(FALSE);
}

CString CSettingsDlg::GetExeFilePathName(CString strTitle, CString strCurrentPath)
{
	int n = strCurrentPath.ReverseFind('\\');
	CString strFileName((n >= 0) ? strCurrentPath.Mid(1 + n) : "");

	CFileDialog fDlg(TRUE, ".exe", strFileName, openFlags, openFilter, NULL);
		
	n = strCurrentPath.ReverseFind('\\');
	CString initDir = strCurrentPath.Left(n + 1);
	fDlg.m_ofn.lpstrInitialDir = (n >= 0) ? initDir : ".\\";
	fDlg.m_ofn.lpstrTitle = strTitle;

	if(IDOK == fDlg.DoModal())
	{
		return fDlg.GetPathName();
	}

	return CString("");
}


void CSettingsDlg::UpdateStaticText()
{
	// fill out captions for helper functions
	char fname[_MAX_FNAME];
	CString aStr;

	_splitpath(m_strPathIExplorer, NULL, NULL, fname, NULL);
	aStr.Format(_T("Internet Browser - %s"), fname);
	CEdit * pEdit = (CEdit *)GetDlgItem(IDC_STATIC_BROWSER);
	pEdit->SetWindowText(aStr);

	_splitpath(m_strPathWinDiff, NULL, NULL, fname, NULL);
	aStr.Format(_T("File Differencing - %s"), fname);
	pEdit = (CEdit *)GetDlgItem(IDC_STATIC_DIFFERENCE);
	pEdit->SetWindowText(aStr);

	_splitpath(m_strPathGraphics, NULL, NULL, fname, NULL);
	aStr.Format(_T("Graphics Viewer - %s"), fname);
	pEdit = (CEdit *)GetDlgItem(IDC_STATIC_GRAPHICS);
	pEdit->SetWindowText(aStr);
}
