// TextDisplayDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTextDisplayDlg dialog


CTextDisplayDlg::CTextDisplayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTextDisplayDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTextDisplayDlg)
	m_editStr = _T("");
	//}}AFX_DATA_INIT
}

void CTextDisplayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTextDisplayDlg)
	DDX_Text(pDX, IDC_EDIT_TEXT_DISPLAY, m_editStr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTextDisplayDlg, CDialog)
	//{{AFX_MSG_MAP(CTextDisplayDlg)
	ON_BN_CLICKED(IDC_BUTTON_GO_TO, OnButtonGoTo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTextDisplayDlg message handlers

BOOL CTextDisplayDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetWindowText(m_captionStr);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// open file and select the searched for text
void CTextDisplayDlg::OnButtonGoTo() 
{
	CString procStr(_T("DicksEditor - Find in Files"));

	CEdit * pEdit = (CEdit *)GetDlgItem(IDC_EDIT_TEXT_DISPLAY);

	int nStart = 0, nAfter = 0;
	pEdit->GetSel(nStart, nAfter);

	char *pBuf = m_editStr.LockBuffer();

	// go to start of number
	while(nStart > 0 && pBuf[nStart] != _T('\n') && pBuf[nStart] != _T(' '))
	{
		nStart--;
	}

	// get file offset for search text
	int nFileStart = 0;

	if(1 == ::sscanf(pBuf + nStart, _T(" %d"), &nFileStart))
	{
		// get start of line
		char *p = pBuf + nStart;

		while(p > pBuf && *(p - 1) != _T('\n'))
		{
			p--;
		}
		// get file name: has form:   \r\nbbFFFFFFFbb--bb   where b = blank F is char in file name (may include blanks)
		char *q = ::strstr(p, _T("  --  ")); 

		char fileName[_MAX_FNAME];
		::strncpy(fileName, p + 2, q - p - 2);
		fileName[q - p - 2] = _T('\0');

		// get directory: has form:  \r\nDDDDDD\r\n  where D is char in directory name (may include blanks)
		while(p > pBuf && !(*(p - 1) == _T('\n') && *p != _T(' ')))
		{
			p--;
		}

		q = ::strstr(p, _T("\r\n"));
		
		char pathName[_MAX_PATH];
		::strncpy(pathName, p, q - p);
		pathName[q - p] = _T('\0');

		// form complete path
		::strcat(pathName,fileName);

		// get search text: has form:  Looking ForbTTTTTT\r\n  where b = blank T = char in text (may include blanks) 
		p = ::strstr(pBuf, _T("Looking For: "));
		p += ::strlen(_T("Looking For: "));
		q = ::strstr(p, _T("\r\n"));

		int nFileAfter = nFileStart + (q - p);

		CString comndLineStr;
		// file path and switches with starting and after offsets in file
		comndLineStr.Format(_T("\"%s\" /iss%d /isa%d"), pathName, nFileStart, nFileAfter); 
		// open a new editor with command line
		CMainFrame * pFrame = (CMainFrame *)AfxGetMainWnd();
		pFrame->OpenNewEditor(comndLineStr, procStr);
	}
	else
	{
		MessageBeep(0xFFFFFFFF);
	}

	m_editStr.UnlockBuffer();	
}

